var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MapView_listener, _IndoorLevel_native, _IndoorBuilding_native, _UISettings_native, _GoogleMap_native, _GoogleMap_mapStyle, _CameraUpdate_native, _CameraPosition_native, _Marker_native, _Marker_color, _Marker_icon, _Circle_native, _Polygon_native, _Polyline_native, _GroundOverlay_native, _GroundOverlay_image, _Poi_native, _TileOverlay_native, _a, _Tile_native, _Tile_NONE, _TileProvider_native, _TileProvider_callback, _UrlTileProvider_native, _UrlTileProvider_callback, _Projection_native, _VisibleRegion_native, _Cap_native, _ButtCap_native, _RoundCap_native, _SquareCap_native, _CustomCap_native, _PatternItem_native, _Dash_native, _Gap_native, _Dot_native;
import { Application, Color, ImageSource, Utils, View } from '@nativescript/core';
import { isNullOrUndefined } from '@nativescript/core/utils/types';
import { bearingProperty, JointType, latProperty, lngProperty, MapType, MapViewBase, tiltProperty, zoomProperty } from './common';
import { intoNativeMarkerOptions, intoNativeCircleOptions, intoNativePolygonOptions, intoNativeGroundOverlayOptions, intoNativePolylineOptions, hueFromColor, intoNativeJointType, toJointType, intoNativeTileOverlayOptions, deserialize, serialize } from './utils';
function fromPatternImages(pattern) {
    const images = [];
    const array = pattern.toArray();
    for (let i = 0; i < array.length; i++) {
        images.push(PatternItem.fromNative(array[i]));
    }
    return images;
}
function intoPatternImages(pattern) {
    const array = new java.util.ArrayList();
    for (let i = 0; i < pattern.length; i++) {
        array.add(pattern[i].native);
    }
    return array;
}
export class MapView extends MapViewBase {
    constructor() {
        super();
        this.createdBundle = null;
        this.savedBundle = null;
        _MapView_listener.set(this, void 0);
        const ref = new WeakRef(this);
        this.lifeCycleHooks = new android.app.Application.ActivityLifecycleCallbacks({
            onActivityCreated(param0, param1) {
                var _b;
                if (param0 !== Application.android.startActivity) {
                    return;
                }
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner) {
                    owner.createdBundle = param1;
                    if (owner.mapView) {
                        owner.mapView.onCreate(param1);
                    }
                }
            },
            onActivityStarted(param0) {
                var _b;
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner === null || owner === void 0 ? void 0 : owner.mapView) {
                    owner.mapView.onStart();
                }
            },
            onActivityResumed(param0) {
                var _b;
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner === null || owner === void 0 ? void 0 : owner.mapView) {
                    owner.mapView.onResume();
                }
            },
            onActivityPaused(param0) {
                var _b;
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner === null || owner === void 0 ? void 0 : owner.mapView) {
                    owner.mapView.onPause();
                }
            },
            onActivityStopped(param0) {
                var _b;
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner === null || owner === void 0 ? void 0 : owner.mapView) {
                    owner.mapView.onStop();
                }
            },
            onActivitySaveInstanceState(param0, param1) {
                var _b;
                if (param0 !== Application.android.startActivity) {
                    return;
                }
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner) {
                    owner.savedBundle = param1;
                    if (owner.mapView) {
                        owner.mapView.onSaveInstanceState(param1);
                    }
                }
            },
            onActivityDestroyed(param0) {
                var _b;
                if (param0 !== Application.android.startActivity) {
                    return;
                }
                const owner = (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                if (owner) {
                    owner.createdBundle = null;
                    owner.savedBundle = null;
                    if (owner.mapView) {
                        owner.mapView.onDestroy();
                    }
                }
            },
        });
        Utils.android.getApplication().registerActivityLifecycleCallbacks(this.lifeCycleHooks);
    }
    createNativeView() {
        const ref = new WeakRef(this);
        __classPrivateFieldSet(this, _MapView_listener, new com.google.android.gms.maps.OnMapReadyCallback({
            onMapReady(map) {
                var _b, _c, _d, _e, _f;
                const owner = (_b = ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                container.addView(nativeView);
                org.nativescript.plugins.google_maps.GoogleMaps.registerMapListeners(map, new org.nativescript.plugins.google_maps.GoogleMaps.Callback({
                    onCameraEvent(position, event, isGesture) {
                        var _b, _c, _d, _e;
                        if (event === 'start') {
                            (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref).notify({
                                eventName: MapView.cameraPositionEvent,
                                object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                                cameraPosition: CameraPosition.fromNative(position),
                                state: event,
                                isGesture,
                            });
                        }
                        else {
                            (_d = ref === null || ref === void 0 ? void 0 : ref.get) === null || _d === void 0 ? void 0 : _d.call(ref).notify({
                                eventName: MapView.cameraPositionEvent,
                                object: (_e = ref === null || ref === void 0 ? void 0 : ref.get) === null || _e === void 0 ? void 0 : _e.call(ref),
                                cameraPosition: CameraPosition.fromNative(position),
                                state: event,
                            });
                        }
                    },
                    onMarkerEvent(marker, event) {
                        var _b, _c, _d, _e, _f, _g, _h, _j;
                        switch (event) {
                            case 'drag':
                                (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref).notify({
                                    eventName: MapView.markerDraggingEvent,
                                    object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                                    marker: Marker.fromNative(marker),
                                });
                                break;
                            case 'start':
                                (_d = ref === null || ref === void 0 ? void 0 : ref.get) === null || _d === void 0 ? void 0 : _d.call(ref).notify({
                                    eventName: MapView.markerDragStartEvent,
                                    object: (_e = ref === null || ref === void 0 ? void 0 : ref.get) === null || _e === void 0 ? void 0 : _e.call(ref),
                                    marker: Marker.fromNative(marker),
                                });
                                break;
                            case 'end':
                                (_f = ref === null || ref === void 0 ? void 0 : ref.get) === null || _f === void 0 ? void 0 : _f.call(ref).notify({
                                    eventName: MapView.markerDragEndEvent,
                                    object: (_g = ref === null || ref === void 0 ? void 0 : ref.get) === null || _g === void 0 ? void 0 : _g.call(ref),
                                    marker: Marker.fromNative(marker),
                                });
                                break;
                            case 'click':
                                (_h = ref === null || ref === void 0 ? void 0 : ref.get) === null || _h === void 0 ? void 0 : _h.call(ref).notify({
                                    eventName: MapView.markerTapEvent,
                                    object: (_j = ref === null || ref === void 0 ? void 0 : ref.get) === null || _j === void 0 ? void 0 : _j.call(ref),
                                    marker: Marker.fromNative(marker),
                                });
                                break;
                        }
                    },
                    onMapClickEvent(latLng, isLongClick) {
                        var _b, _c, _d, _e;
                        if (isLongClick) {
                            (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref).notify({
                                eventName: MapView.mapLongPressEvent,
                                object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                                coordinate: {
                                    lat: latLng.latitude,
                                    lng: latLng.longitude,
                                },
                            });
                        }
                        else {
                            (_d = ref === null || ref === void 0 ? void 0 : ref.get) === null || _d === void 0 ? void 0 : _d.call(ref).notify({
                                eventName: MapView.mapTapEvent,
                                object: (_e = ref === null || ref === void 0 ? void 0 : ref.get) === null || _e === void 0 ? void 0 : _e.call(ref),
                                coordinate: {
                                    lat: latLng.latitude,
                                    lng: latLng.longitude,
                                },
                            });
                        }
                    },
                    onMyLocationEvent(location) {
                        var _b, _c, _d, _e;
                        if (location) {
                            (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref).notify({
                                eventName: MapView.myLocationButtonTapEvent,
                                object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                            });
                        }
                        else {
                            (_d = ref === null || ref === void 0 ? void 0 : ref.get) === null || _d === void 0 ? void 0 : _d.call(ref).notify({
                                eventName: MapView.myLocationButtonTapEvent,
                                object: (_e = ref === null || ref === void 0 ? void 0 : ref.get) === null || _e === void 0 ? void 0 : _e.call(ref),
                            });
                        }
                    },
                    onItemClickEvent(item, name) {
                        var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
                        switch (name) {
                            case 'circle':
                                (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref).notify({
                                    eventName: MapView.circleTapEvent,
                                    object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                                    circle: Circle.fromNative(item),
                                });
                                break;
                            case 'polygon':
                                (_d = ref === null || ref === void 0 ? void 0 : ref.get) === null || _d === void 0 ? void 0 : _d.call(ref).notify({
                                    eventName: MapView.polygonTapEvent,
                                    object: (_e = ref === null || ref === void 0 ? void 0 : ref.get) === null || _e === void 0 ? void 0 : _e.call(ref),
                                    polygon: Polygon.fromNative(item),
                                });
                                break;
                            case 'polyline':
                                (_f = ref === null || ref === void 0 ? void 0 : ref.get) === null || _f === void 0 ? void 0 : _f.call(ref).notify({
                                    eventName: MapView.polylineTapEvent,
                                    object: (_g = ref === null || ref === void 0 ? void 0 : ref.get) === null || _g === void 0 ? void 0 : _g.call(ref),
                                    polyline: Polyline.fromNative(item),
                                });
                                break;
                            case 'poi':
                                (_h = ref === null || ref === void 0 ? void 0 : ref.get) === null || _h === void 0 ? void 0 : _h.call(ref).notify({
                                    eventName: MapView.poiTapEvent,
                                    object: (_j = ref === null || ref === void 0 ? void 0 : ref.get) === null || _j === void 0 ? void 0 : _j.call(ref),
                                    poi: Poi.fromNative(item),
                                });
                                break;
                            case 'groundOverlay':
                                (_k = ref === null || ref === void 0 ? void 0 : ref.get) === null || _k === void 0 ? void 0 : _k.call(ref).notify({
                                    eventName: MapView.groundOverlayTapEvent,
                                    object: (_l = ref === null || ref === void 0 ? void 0 : ref.get) === null || _l === void 0 ? void 0 : _l.call(ref),
                                    groundOverlay: GroundOverlay.fromNative(item),
                                });
                                break;
                        }
                    },
                    onInfoWindowEvent(marker, event, isLongClick) {
                        var _b, _c, _d, _e;
                        let info = {
                            eventName: MapView.infoWindowTapEvent,
                            object: (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref),
                            marker: Marker.fromNative(marker),
                        };
                        if (event === 'click') {
                            if (isLongClick) {
                                info.eventName = MapView.infoWindowLongPressEvent;
                            }
                        }
                        else if (event === 'close') {
                            info.eventName = MapView.infoWindowCloseEvent;
                        }
                        else {
                            info = null;
                        }
                        if (info) {
                            (_e = (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : (_d = _c.call(ref)).notify) === null || _e === void 0 ? void 0 : _e.call(_d, info);
                        }
                    },
                    onInfoWindowAdapterEvent(marker, event) {
                        var _b, _c, _d, _e, _f, _g, _h;
                        const owner = (_b = ref.get) === null || _b === void 0 ? void 0 : _b.call(ref);
                        if (owner) {
                            let info = {
                                eventName: '',
                                object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                                marker: Marker.fromNative(marker),
                                view: null,
                            };
                            if (event === 'contents') {
                                info.eventName = MapView.markerInfoContentsEvent;
                            }
                            else if (event === 'window') {
                                info.eventName = MapView.markerInfoWindowEvent;
                            }
                            else {
                                info = null;
                            }
                            if (info) {
                                owner.notify(info);
                                if (info.view instanceof View) {
                                    if (!info.view.parent && !((_d = info.view) === null || _d === void 0 ? void 0 : _d.nativeView)) {
                                        owner._addView(info.view);
                                    }
                                    if (info.view.nativeView && !marker._view) {
                                        marker._view = new android.widget.RelativeLayout(owner._context);
                                    }
                                    const parent = (_f = (_e = info.view.nativeView) === null || _e === void 0 ? void 0 : _e.getParent) === null || _f === void 0 ? void 0 : _f.call(_e);
                                    if (info.view.nativeView && parent !== marker._view) {
                                        if (parent && parent.removeView) {
                                            parent.removeView(info.view.nativeView);
                                        }
                                        const container = marker._view;
                                        container.addView(info.view.nativeView);
                                    }
                                    return (_h = (_g = marker) === null || _g === void 0 ? void 0 : _g._view) !== null && _h !== void 0 ? _h : null;
                                }
                            }
                        }
                        return null;
                    },
                    onIndoorEvent(object, name) {
                        var _b, _c, _d, _e;
                        if (name === 'buildingFocused') {
                            (_b = ref === null || ref === void 0 ? void 0 : ref.get) === null || _b === void 0 ? void 0 : _b.call(ref).notify({
                                eventName: MapView.activeBuildingEvent,
                                object: (_c = ref === null || ref === void 0 ? void 0 : ref.get) === null || _c === void 0 ? void 0 : _c.call(ref),
                                building: IndoorBuilding.fromNative(object),
                            });
                        }
                        else if (name === 'levelActivated') {
                            const building = object;
                            const level = building.getLevels().get(building.getActiveLevelIndex());
                            (_d = ref === null || ref === void 0 ? void 0 : ref.get) === null || _d === void 0 ? void 0 : _d.call(ref).notify({
                                eventName: MapView.activeLevelEvent,
                                object: (_e = ref === null || ref === void 0 ? void 0 : ref.get) === null || _e === void 0 ? void 0 : _e.call(ref),
                                level: IndoorLevel.fromNative(level),
                            });
                        }
                    },
                }));
                if (owner) {
                    owner._map = map;
                    owner._updateCamera(map, {
                        lat: owner.lat,
                        lng: owner.lng,
                        bearing: owner.bearing,
                        tilt: owner.tilt,
                        zoom: owner.zoom,
                    });
                }
                (_e = (_c = ref.get) === null || _c === void 0 ? void 0 : (_d = _c.call(ref)).notify) === null || _e === void 0 ? void 0 : _e.call(_d, {
                    eventName: 'ready',
                    object: (_f = ref.get) === null || _f === void 0 ? void 0 : _f.call(ref),
                    map: GoogleMap.fromNative(map),
                });
            },
        }), "f");
        const container = new android.widget.LinearLayout(this._context);
        const nativeView = new com.google.android.gms.maps.MapView(this._context);
        nativeView.getMapAsync(__classPrivateFieldGet(this, _MapView_listener, "f"));
        this.mapView = nativeView;
        nativeView.onCreate(this.createdBundle);
        nativeView.onResume();
        return container;
    }
    initNativeView() {
        super.initNativeView();
    }
    [(_MapView_listener = new WeakMap(), latProperty.setNative)](value) {
        if (this._map) {
            this._updateCamera(this._map, {
                lat: value,
            });
        }
    }
    [lngProperty.setNative](value) {
        if (this._map) {
            this._updateCamera(this._map, {
                lng: value,
            });
        }
    }
    [zoomProperty.setNative](value) {
        if (this._map) {
            this._updateCamera(this._map, {
                zoom: value,
            });
        }
    }
    [tiltProperty.setNative](value) {
        if (this._map) {
            this._updateCamera(this._map, {
                tilt: value,
            });
        }
    }
    [bearingProperty.setNative](value) {
        if (this._map) {
            this._updateCamera(this._map, {
                bearing: value,
            });
        }
    }
    _updateCamera(map, owner) {
        const googleMap = GoogleMap.fromNative(map);
        if (googleMap) {
            const position = CameraPosition.fromNative(map.getCameraPosition());
            let changed = false;
            if (!isNullOrUndefined(owner.lat)) {
                position.target = {
                    lat: typeof owner.lat === 'string' ? parseFloat(owner.lat) : owner.lat,
                    lng: position.target.lng,
                };
                changed = true;
            }
            if (!isNullOrUndefined(owner.lng)) {
                position.target = {
                    lat: position.target.lat,
                    lng: typeof owner.lng === 'string' ? parseFloat(owner.lng) : owner.lng,
                };
                changed = true;
            }
            if (!isNullOrUndefined(owner.zoom)) {
                position.zoom = typeof owner.zoom === 'string' ? parseFloat(owner.zoom) : owner.zoom;
                changed = true;
            }
            if (!isNullOrUndefined(owner.tilt)) {
                position.tilt = typeof owner.tilt === 'string' ? parseFloat(owner.tilt) : owner.tilt;
                changed = true;
            }
            if (!isNullOrUndefined(owner.bearing)) {
                position.bearing = typeof owner.bearing === 'string' ? parseFloat(owner.bearing) : owner.bearing;
                changed = true;
            }
            if (changed) {
                googleMap.cameraPosition = position;
            }
        }
    }
}
export class IndoorLevel {
    constructor() {
        _IndoorLevel_native.set(this, void 0);
    }
    static fromNative(nativeIndoorLevel) {
        if (nativeIndoorLevel instanceof com.google.android.gms.maps.model.IndoorLevel) {
            const indoorLevel = new IndoorLevel();
            __classPrivateFieldSet(indoorLevel, _IndoorLevel_native, nativeIndoorLevel, "f");
            return indoorLevel;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _IndoorLevel_native, "f");
    }
    get android() {
        return this.native;
    }
    get name() {
        return this.native.getName();
    }
    get shortName() {
        return this.native.getShortName();
    }
}
_IndoorLevel_native = new WeakMap();
export class IndoorBuilding {
    constructor() {
        _IndoorBuilding_native.set(this, void 0);
    }
    static fromNative(nativeIndoorBuilding) {
        if (nativeIndoorBuilding instanceof com.google.android.gms.maps.model.IndoorBuilding) {
            const indoorBuilding = new IndoorBuilding();
            __classPrivateFieldSet(indoorBuilding, _IndoorBuilding_native, nativeIndoorBuilding, "f");
            return indoorBuilding;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _IndoorBuilding_native, "f");
    }
    get android() {
        return this.native;
    }
    get defaultLevelIndex() {
        return this.native.getDefaultLevelIndex();
    }
    get levels() {
        const result = [];
        const levels = this.native.getLevels().toArray();
        for (let i = 0; i < levels.length; i++) {
            result.push(IndoorLevel.fromNative(levels[i]));
        }
        return result;
    }
    get underground() {
        return this.native.isUnderground();
    }
}
_IndoorBuilding_native = new WeakMap();
export class UISettings {
    constructor() {
        _UISettings_native.set(this, void 0);
    }
    static fromNative(nativeUiSettings) {
        if (nativeUiSettings instanceof com.google.android.gms.maps.UiSettings) {
            const settings = new UISettings();
            __classPrivateFieldSet(settings, _UISettings_native, nativeUiSettings, "f");
            return settings;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _UISettings_native, "f");
    }
    get android() {
        return this.native;
    }
    get mapToolbarEnabled() {
        return this.native.isMapToolbarEnabled();
    }
    set mapToolbarEnabled(value) {
        this.native.setMapToolbarEnabled(value);
    }
    get zoomControlsEnabled() {
        return this.native.isZoomControlsEnabled();
    }
    set zoomControlsEnabled(value) {
        this.native.setZoomControlsEnabled(value);
    }
    get zoomGesturesEnabled() {
        return this.native.isZoomGesturesEnabled();
    }
    set zoomGesturesEnabled(value) {
        this.native.setZoomGesturesEnabled(value);
    }
    get tiltGesturesEnabled() {
        return this.native.isTiltGesturesEnabled();
    }
    set tiltGesturesEnabled(value) {
        this.native.setTiltGesturesEnabled(value);
    }
    setAllGesturesEnabled(value) {
        this.native.setAllGesturesEnabled(value);
    }
    get compassEnabled() {
        return this.native.isCompassEnabled();
    }
    set compassEnabled(value) {
        this.native.setCompassEnabled(value);
    }
    get scrollGesturesEnabledDuringRotateOrZoom() {
        return this.native.isScrollGesturesEnabledDuringRotateOrZoom();
    }
    set scrollGesturesEnabledDuringRotateOrZoom(value) {
        this.native.setScrollGesturesEnabledDuringRotateOrZoom(value);
    }
    get rotateGesturesEnabled() {
        return this.native.isRotateGesturesEnabled();
    }
    get myLocationButtonEnabled() {
        return this.native.isMyLocationButtonEnabled();
    }
    get indoorLevelPickerEnabled() {
        return this.native.isIndoorLevelPickerEnabled();
    }
    get scrollGesturesEnabled() {
        return this.native.isScrollGesturesEnabled();
    }
}
_UISettings_native = new WeakMap();
export class GoogleMap {
    constructor() {
        _GoogleMap_native.set(this, void 0);
        _GoogleMap_mapStyle.set(this, void 0);
    }
    static fromNative(nativeMap) {
        if (nativeMap instanceof com.google.android.gms.maps.GoogleMap) {
            const map = new GoogleMap();
            __classPrivateFieldSet(map, _GoogleMap_native, nativeMap, "f");
            return map;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _GoogleMap_native, "f");
    }
    get android() {
        return this.native;
    }
    get cameraPosition() {
        return CameraPosition.fromNative(this.native.getCameraPosition());
    }
    set cameraPosition(value) {
        this.native.moveCamera(CameraUpdate.fromCameraPosition(value).native);
    }
    set mapType(type) {
        switch (type) {
            case MapType.None:
                this.native.setMapType(com.google.android.gms.maps.GoogleMap.MAP_TYPE_NONE);
                break;
            case MapType.Normal:
                this.native.setMapType(com.google.android.gms.maps.GoogleMap.MAP_TYPE_NORMAL);
                break;
            case MapType.Satellite:
                this.native.setMapType(com.google.android.gms.maps.GoogleMap.MAP_TYPE_SATELLITE);
                break;
            case MapType.Terrain:
                this.native.setMapType(com.google.android.gms.maps.GoogleMap.MAP_TYPE_TERRAIN);
                break;
            case MapType.Hybrid:
                this.native.setMapType(com.google.android.gms.maps.GoogleMap.MAP_TYPE_HYBRID);
                break;
        }
    }
    get mapType() {
        switch (this.native.getMapType()) {
            case com.google.android.gms.maps.GoogleMap.MAP_TYPE_NONE:
                return MapType.None;
            case com.google.android.gms.maps.GoogleMap.MAP_TYPE_NORMAL:
                return MapType.Normal;
            case com.google.android.gms.maps.GoogleMap.MAP_TYPE_SATELLITE:
                return MapType.Satellite;
            case com.google.android.gms.maps.GoogleMap.MAP_TYPE_TERRAIN:
                return MapType.Terrain;
            case com.google.android.gms.maps.GoogleMap.MAP_TYPE_HYBRID:
                return MapType.Hybrid;
        }
    }
    get uiSettings() {
        return UISettings.fromNative(this.native.getUiSettings());
    }
    get trafficEnabled() {
        return this.native.isTrafficEnabled();
    }
    set trafficEnabled(value) {
        this.native.setTrafficEnabled(value);
    }
    get maxZoomLevel() {
        return this.native.getMaxZoomLevel();
    }
    set maxZoomLevel(value) {
        this.native.setMaxZoomPreference(value);
    }
    set minZoomLevel(value) {
        this.native.setMinZoomPreference(value);
    }
    get minZoomLevel() {
        return this.native.getMinZoomLevel();
    }
    get buildingsEnabled() {
        return this.native.isBuildingsEnabled();
    }
    set buildingsEnabled(value) {
        this.native.setBuildingsEnabled(value);
    }
    get myLocationEnabled() {
        return this.native.isMyLocationEnabled();
    }
    set myLocationEnabled(value) {
        this.native.setMyLocationEnabled(value);
    }
    get projection() {
        return Projection.fromNative(this.native.getProjection());
    }
    get mapStyle() {
        return __classPrivateFieldGet(this, _GoogleMap_mapStyle, "f");
    }
    set mapStyle(value) {
        try {
            const style = new com.google.android.gms.maps.model.MapStyleOptions(JSON.stringify(value));
            this.native.setMapStyle(style);
        }
        catch (e) {
            console.error(e);
        }
    }
    animateCamera(update) {
        this.native.animateCamera(update.native);
    }
    clear() {
        this.native.clear();
    }
    addMarker(options) {
        const marker = Marker.fromNative(this.native.addMarker(intoNativeMarkerOptions(options)));
        if (options === null || options === void 0 ? void 0 : options.userData) {
            marker.userData = options.userData;
        }
        return marker;
    }
    removeMarker(marker) {
        var _b, _c;
        (_c = (_b = marker === null || marker === void 0 ? void 0 : marker.native) === null || _b === void 0 ? void 0 : _b.remove) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
    addCircle(options) {
        return Circle.fromNative(this.native.addCircle(intoNativeCircleOptions(options)));
    }
    removeCircle(circle) {
        var _b, _c;
        (_c = (_b = circle === null || circle === void 0 ? void 0 : circle.native) === null || _b === void 0 ? void 0 : _b.remove) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
    addPolygon(options) {
        return Polygon.fromNative(this.native.addPolygon(intoNativePolygonOptions(options)));
    }
    removePolygon(polygon) {
        var _b, _c;
        (_c = (_b = polygon === null || polygon === void 0 ? void 0 : polygon.native) === null || _b === void 0 ? void 0 : _b.remove) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
    addPolyline(options) {
        return Polyline.fromNative(this.native.addPolyline(intoNativePolylineOptions(options)));
    }
    removePolyline(polyline) {
        var _b, _c;
        (_c = (_b = polyline === null || polyline === void 0 ? void 0 : polyline.native) === null || _b === void 0 ? void 0 : _b.remove) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
    addGroundOverlay(options) {
        return GroundOverlay.fromNative(this.native.addGroundOverlay(intoNativeGroundOverlayOptions(options)));
    }
    removeGroundOverlay(groundOverlay) {
        var _b, _c;
        (_c = (_b = groundOverlay === null || groundOverlay === void 0 ? void 0 : groundOverlay.native) === null || _b === void 0 ? void 0 : _b.remove) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
    snapshot() {
        return new Promise((resolve, reject) => {
            this.native.snapshot(new com.google.android.gms.maps.GoogleMap.SnapshotReadyCallback({
                onSnapshotReady(ss) {
                    resolve(new ImageSource(ss));
                },
            }));
        });
    }
    addTileOverlay(options) {
        return TileOverlay.fromNative(this.native.addTileOverlay(intoNativeTileOverlayOptions(options)));
    }
    removeTileOverlay(overlay) {
        var _b, _c;
        (_c = (_b = overlay === null || overlay === void 0 ? void 0 : overlay.native) === null || _b === void 0 ? void 0 : _b.remove) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
}
_GoogleMap_native = new WeakMap(), _GoogleMap_mapStyle = new WeakMap();
export class CameraUpdate {
    constructor() {
        _CameraUpdate_native.set(this, void 0);
    }
    static fromNative(nativeUpdate) {
        if (nativeUpdate instanceof com.google.android.gms.maps.CameraUpdate) {
            const update = new CameraUpdate();
            __classPrivateFieldSet(update, _CameraUpdate_native, nativeUpdate, "f");
            return update;
        }
        return null;
    }
    static fromCoordinate(coordinate, zoom) {
        if (typeof zoom === 'number') {
            return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.newLatLngZoom(new com.google.android.gms.maps.model.LatLng(coordinate.lat, coordinate.lng), zoom));
        }
        else {
            return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.newLatLng(new com.google.android.gms.maps.model.LatLng(coordinate.lat, coordinate.lng)));
        }
    }
    static fromCameraPosition(position) {
        return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.newCameraPosition(position.native));
    }
    static zoomIn() {
        return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.zoomIn());
    }
    static zoomOut() {
        return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.zoomOut());
    }
    static zoomTo(value) {
        return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.zoomTo(value));
    }
    static zoomBy(amount, point) {
        if (typeof (point === null || point === void 0 ? void 0 : point.x) === 'number' && typeof point.y === 'number') {
            return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.zoomBy(amount, new android.graphics.Point(point.x, point.y)));
        }
        else {
            return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.zoomBy(amount));
        }
    }
    static scrollBy(x, y) {
        return CameraUpdate.fromNative(com.google.android.gms.maps.CameraUpdateFactory.scrollBy(x, y));
    }
    get native() {
        return __classPrivateFieldGet(this, _CameraUpdate_native, "f");
    }
    get android() {
        return this.native;
    }
}
_CameraUpdate_native = new WeakMap();
export class CameraPosition {
    constructor(target, zoom, bearing, tilt) {
        _CameraPosition_native.set(this, void 0);
        if (target && typeof zoom === 'number') {
            const builder = com.google.android.gms.maps.model.CameraPosition.builder();
            builder.target(new com.google.android.gms.maps.model.LatLng(target.lat, target.lng));
            builder.zoom(zoom);
            if (typeof bearing === 'number') {
                builder.bearing(bearing);
            }
            if (typeof tilt === 'number') {
                builder.tilt(tilt);
            }
            __classPrivateFieldSet(this, _CameraPosition_native, builder.build(), "f");
        }
    }
    static fromNative(nativePosition) {
        if (nativePosition instanceof com.google.android.gms.maps.model.CameraPosition) {
            const position = new CameraPosition(null, null);
            __classPrivateFieldSet(position, _CameraPosition_native, nativePosition, "f");
            return position;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _CameraPosition_native, "f");
    }
    get android() {
        return this.native;
    }
    get bearing() {
        return this.native.bearing;
    }
    set bearing(value) {
        __classPrivateFieldSet(this, _CameraPosition_native, new com.google.android.gms.maps.model.CameraPosition(this.native.target, this.native.zoom, this.native.tilt, value), "f");
    }
    get target() {
        return {
            lat: this.native.target.latitude,
            lng: this.native.target.longitude,
        };
    }
    set target(value) {
        __classPrivateFieldSet(this, _CameraPosition_native, new com.google.android.gms.maps.model.CameraPosition(new com.google.android.gms.maps.model.LatLng(value.lat, value.lng), this.native.zoom, this.native.tilt, this.native.bearing), "f");
    }
    get tilt() {
        return this.native.tilt;
    }
    set tilt(value) {
        __classPrivateFieldSet(this, _CameraPosition_native, new com.google.android.gms.maps.model.CameraPosition(this.native.target, this.native.zoom, value, this.native.bearing), "f");
    }
    get zoom() {
        return this.native.zoom;
    }
    set zoom(value) {
        __classPrivateFieldSet(this, _CameraPosition_native, new com.google.android.gms.maps.model.CameraPosition(this.native.target, value, this.native.tilt, this.native.bearing), "f");
    }
    toJSON() {
        return {
            target: this.target,
            tilt: this.tilt,
            bearing: this.bearing,
            zoom: this.zoom,
        };
    }
}
_CameraPosition_native = new WeakMap();
class OverLayBase {
    get userData() {
        const userData = this.native.getUserData();
        if (userData instanceof java.util.HashMap) {
            return deserialize(userData);
        }
        return {};
    }
    set userData(data) {
        if (data && typeof data === 'object') {
            this.native.setUserData(serialize(data));
        }
        else {
            this.native.setUserData(null);
        }
    }
}
export class Marker extends OverLayBase {
    constructor() {
        super();
        _Marker_native.set(this, void 0);
        _Marker_color.set(this, void 0);
        _Marker_icon.set(this, void 0);
        __classPrivateFieldSet(this, _Marker_icon, new ImageSource(), "f");
        __classPrivateFieldSet(this, _Marker_color, new Color('red'), "f");
    }
    static fromNative(nativeMarker) {
        if (nativeMarker instanceof com.google.android.gms.maps.model.Marker) {
            const marker = new Marker();
            __classPrivateFieldSet(marker, _Marker_native, nativeMarker, "f");
            return marker;
        }
        return null;
    }
    _setIcon(icon) {
        __classPrivateFieldSet(this, _Marker_icon, icon, "f");
    }
    _setColor(color) {
        __classPrivateFieldSet(this, _Marker_color, color, "f");
    }
    get rotation() {
        return this.native.getRotation();
    }
    set rotation(value) {
        this.native.setRotation(value);
    }
    get flat() {
        return this.native.isFlat();
    }
    set flat(value) {
        this.native.setFlat(value);
    }
    get color() {
        return __classPrivateFieldGet(this, _Marker_color, "f");
    }
    set color(value) {
        if (value instanceof Color) {
            __classPrivateFieldSet(this, _Marker_color, value, "f");
            this.native.setIcon(com.google.android.gms.maps.model.BitmapDescriptorFactory.defaultMarker(hueFromColor(__classPrivateFieldGet(this, _Marker_color, "f"))));
        }
        else if (typeof value === 'string') {
            __classPrivateFieldSet(this, _Marker_color, new Color(value), "f");
            this.native.setIcon(com.google.android.gms.maps.model.BitmapDescriptorFactory.defaultMarker(hueFromColor(__classPrivateFieldGet(this, _Marker_color, "f"))));
        }
    }
    get icon() {
        return __classPrivateFieldGet(this, _Marker_icon, "f");
    }
    set icon(value) {
        if (value instanceof android.graphics.Bitmap) {
            const desc = com.google.android.gms.maps.model.BitmapDescriptorFactory.fromBitmap(value);
            this.native.setIcon(desc);
            __classPrivateFieldGet(this, _Marker_icon, "f").setNativeSource(value);
        }
        else if (value instanceof ImageSource) {
            __classPrivateFieldSet(this, _Marker_icon, value, "f");
            const desc = com.google.android.gms.maps.model.BitmapDescriptorFactory.fromBitmap(value.android);
            this.native.setIcon(desc);
        }
    }
    get draggable() {
        return this.native.isDraggable();
    }
    set draggable(value) {
        this.native.setDraggable(value);
    }
    get native() {
        return __classPrivateFieldGet(this, _Marker_native, "f");
    }
    get android() {
        return this.native;
    }
    get position() {
        const position = this.native.getPosition();
        return {
            lat: position.latitude,
            lng: position.longitude,
        };
    }
    set position(latlng) {
        const position = new com.google.android.gms.maps.model.LatLng(latlng.lat, latlng.lng);
        this.native.setPosition(position);
    }
    get title() {
        return this.native.getTitle();
    }
    set title(value) {
        this.native.setTitle(value);
    }
    get snippet() {
        return this.native.getSnippet();
    }
    set snippet(value) {
        this.native.setSnippet(value);
    }
    get zIndex() {
        return this.native.getZIndex();
    }
    set zIndex(value) {
        this.native.setZIndex(value);
    }
    hideInfoWindow() {
        this.native.hideInfoWindow();
    }
    showInfoWindow() {
        this.native.showInfoWindow();
    }
}
_Marker_native = new WeakMap(), _Marker_color = new WeakMap(), _Marker_icon = new WeakMap();
export class Circle extends OverLayBase {
    constructor() {
        super(...arguments);
        _Circle_native.set(this, void 0);
    }
    static fromNative(nativeCircle) {
        if (nativeCircle instanceof com.google.android.gms.maps.model.Circle) {
            const circle = new Circle();
            __classPrivateFieldSet(circle, _Circle_native, nativeCircle, "f");
            return circle;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Circle_native, "f");
    }
    get android() {
        return this.native;
    }
    get radius() {
        return this.native.getRadius();
    }
    set radius(value) {
        this.native.setRadius(value);
    }
    get strokeColor() {
        return new Color(this.native.getStrokeColor());
    }
    set strokeColor(value) {
        if (value instanceof Color) {
            this.native.setStrokeColor(value.android);
        }
        else if (typeof value === 'string') {
            this.native.setStrokeColor(new Color(value).android);
        }
    }
    get center() {
        const center = this.native.getCenter();
        return {
            lat: center.latitude,
            lng: center.longitude,
        };
    }
    set center(value) {
        this.native.setCenter(new com.google.android.gms.maps.model.LatLng(value.lat, value.lng));
    }
    get fillColor() {
        return new Color(this.native.getFillColor());
    }
    set fillColor(value) {
        if (value instanceof Color) {
            this.native.setFillColor(value.android);
        }
        else if (typeof value === 'string') {
            this.native.setFillColor(new Color(value).android);
        }
    }
    get visible() {
        return this.native.isVisible();
    }
    set visible(value) {
        this.native.setVisible(value);
    }
    get tappable() {
        return this.native.isClickable();
    }
    set tappable(value) {
        this.native.setClickable(value);
    }
    get strokeWidth() {
        return this.native.getStrokeWidth();
    }
    set strokeWidth(value) {
        this.native.setStrokeWidth(value);
    }
    get strokePattern() {
        return fromPatternImages(this.native.getStrokePattern());
    }
    set strokePattern(value) {
        this.native.setStrokePattern(intoPatternImages(value));
    }
    get zIndex() {
        return this.native.getZIndex();
    }
    set zIndex(value) {
        this.native.setZIndex(value);
    }
}
_Circle_native = new WeakMap();
export class Polygon extends OverLayBase {
    constructor() {
        super(...arguments);
        _Polygon_native.set(this, void 0);
    }
    static fromNative(nativePolygon) {
        if (nativePolygon instanceof com.google.android.gms.maps.model.Polygon) {
            const polygon = new Polygon();
            __classPrivateFieldSet(polygon, _Polygon_native, nativePolygon, "f");
            return polygon;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Polygon_native, "f");
    }
    get android() {
        return this.native;
    }
    get points() {
        const array = this.native.getPoints().toArray();
        const points = [];
        for (let i = 0; i < array.length; i++) {
            const point = array[i];
            points.push({
                lat: point.latitude,
                lng: point.longitude,
            });
        }
        return points;
    }
    set points(value) {
        if (Array.isArray(value)) {
            const nativeArray = new java.util.ArrayList();
            value.forEach((point) => {
                nativeArray.add(new com.google.android.gms.maps.model.LatLng(point.lat, point.lng));
            });
            this.native.setPoints(nativeArray);
        }
    }
    get holes() {
        const array = this.native.getHoles().toArray();
        const holes = [];
        for (let i = 0; i < array.length; i++) {
            const hole = array[i];
            holes.push({
                lat: hole.latitude,
                lng: hole.longitude,
            });
        }
        return holes;
    }
    set holes(value) {
        if (Array.isArray(value)) {
            const nativeArray = new java.util.ArrayList();
            value.forEach((hole) => {
                nativeArray.add(new com.google.android.gms.maps.model.LatLng(hole.lat, hole.lng));
            });
            this.native.setHoles(nativeArray);
        }
    }
    get tappable() {
        return this.native.isClickable();
    }
    set tappable(value) {
        this.native.setClickable(value);
    }
    get strokeWidth() {
        return this.native.getStrokeWidth();
    }
    set strokeWidth(value) {
        this.native.setStrokeWidth(value);
    }
    get strokeColor() {
        return new Color(this.native.getStrokeColor());
    }
    set strokeColor(value) {
        if (value instanceof Color) {
            this.native.setStrokeColor(value.android);
        }
        else if (typeof value === 'string') {
            this.native.setStrokeColor(new Color(value).android);
        }
    }
    get strokePattern() {
        return fromPatternImages(this.native.getStrokePattern());
    }
    set strokePattern(value) {
        this.native.setStrokePattern(intoPatternImages(value));
    }
    get zIndex() {
        return this.native.getZIndex();
    }
    set zIndex(value) {
        this.native.setZIndex(value);
    }
    get geodesic() {
        return this.native.isGeodesic();
    }
    set geodesic(value) {
        this.native.setGeodesic(value);
    }
    get strokeJointType() {
        switch (this.native.getStrokeJointType()) {
            case com.google.android.gms.maps.model.JointType.ROUND:
                return JointType.Round;
            case com.google.android.gms.maps.model.JointType.BEVEL:
                return JointType.Bevel;
            default:
                return JointType.Default;
        }
    }
    set strokeJointType(value) {
        this.native.setStrokeJointType(intoNativeJointType(value));
    }
    get visible() {
        return this.native.isVisible();
    }
    set visible(value) {
        this.native.setVisible(value);
    }
    get fillColor() {
        return new Color(this.native.getFillColor());
    }
    set fillColor(value) {
        if (value instanceof Color) {
            this.native.setFillColor(value.android);
        }
        else if (typeof value === 'string') {
            this.native.setFillColor(new Color(value).android);
        }
    }
}
_Polygon_native = new WeakMap();
export class Polyline extends OverLayBase {
    constructor() {
        super(...arguments);
        _Polyline_native.set(this, void 0);
    }
    static fromNative(nativePolyline) {
        if (nativePolyline instanceof com.google.android.gms.maps.model.Polyline) {
            const polyline = new Polyline();
            __classPrivateFieldSet(polyline, _Polyline_native, nativePolyline, "f");
            return polyline;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Polyline_native, "f");
    }
    get android() {
        return this.native;
    }
    get width() {
        return this.native.getWidth();
    }
    get points() {
        const array = this.native.getPoints().toArray();
        const points = [];
        for (let i = 0; i < array.length; i++) {
            const point = array[i];
            points.push({
                lat: point.latitude,
                lng: point.longitude,
            });
        }
        return points;
    }
    set points(value) {
        if (Array.isArray(value)) {
            const nativeArray = new java.util.ArrayList();
            value.forEach((point) => {
                nativeArray.add(new com.google.android.gms.maps.model.LatLng(point.lat, point.lng));
            });
            this.native.setPoints(nativeArray);
        }
    }
    get tappable() {
        return this.native.isClickable();
    }
    set tappable(value) {
        this.native.setClickable(value);
    }
    get geodesic() {
        return this.native.isGeodesic();
    }
    set geodesic(value) {
        this.native.setGeodesic(value);
    }
    get visible() {
        return this.native.isVisible();
    }
    set visible(value) {
        this.native.setVisible(value);
    }
    get zIndex() {
        return this.native.getZIndex();
    }
    set zIndex(value) {
        this.native.setZIndex(value);
    }
    get jointType() {
        return toJointType(this.native.getJointType());
    }
    set jointType(value) {
        this.native.setJointType(intoNativeJointType(value));
    }
    get pattern() {
        return fromPatternImages(this.native.getPattern());
    }
    set pattern(value) {
        this.native.setPattern(intoPatternImages(value));
    }
    get color() {
        return new Color(this.native.getColor());
    }
    set color(value) {
        if (value instanceof Color) {
            this.native.setColor(value.android);
        }
        else if (typeof value === 'string') {
            this.native.setColor(new Color(value).android);
        }
    }
    get startCap() {
        return Cap.fromNative(this.native.getStartCap());
    }
    set startCap(cap) {
        this.native.setStartCap(cap.native);
    }
    get endCap() {
        return Cap.fromNative(this.native.getEndCap());
    }
    set endCap(cap) {
        this.native.setEndCap(cap.native);
    }
}
_Polyline_native = new WeakMap();
export class GroundOverlay extends OverLayBase {
    constructor() {
        super();
        _GroundOverlay_native.set(this, void 0);
        _GroundOverlay_image.set(this, void 0);
        __classPrivateFieldSet(this, _GroundOverlay_image, new ImageSource(), "f");
    }
    static fromNative(nativeGroundOverlayOptions) {
        if (nativeGroundOverlayOptions instanceof com.google.android.gms.maps.model.GroundOverlay) {
            const groundOverlayOptions = new GroundOverlay();
            __classPrivateFieldSet(groundOverlayOptions, _GroundOverlay_native, nativeGroundOverlayOptions, "f");
            return groundOverlayOptions;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _GroundOverlay_native, "f");
    }
    get android() {
        return this.native;
    }
    get zIndex() {
        return this.native.getZIndex();
    }
    set zIndex(value) {
        this.native.setZIndex(value);
    }
    set visible(value) {
        this.native.setVisible(value);
    }
    get visible() {
        return this.native.isVisible();
    }
    get transparency() {
        return this.native.getTransparency();
    }
    set transparency(value) {
        this.native.setTransparency(value);
    }
    set position(value) {
        this.native.setPosition(new com.google.android.gms.maps.model.LatLng(value.lat, value.lng));
    }
    get position() {
        const coord = this.native.getPosition();
        return {
            lat: coord.latitude,
            lng: coord.longitude,
        };
    }
    get width() {
        return this.native.getWidth();
    }
    get height() {
        return this.native.getHeight();
    }
    get bounds() {
        const bounds = this.native.getBounds();
        return {
            southwest: {
                lat: bounds.southwest.latitude,
                lng: bounds.southwest.longitude,
            },
            northeast: {
                lat: bounds.northeast.latitude,
                lng: bounds.northeast.longitude,
            },
        };
    }
    get tappable() {
        return this.native.isClickable();
    }
    set tappable(value) {
        this.native.setClickable(value);
    }
    get bearing() {
        return this.native.getBearing();
    }
    set bearing(value) {
        this.native.setBearing(value);
    }
    get image() {
        return __classPrivateFieldGet(this, _GroundOverlay_image, "f");
    }
}
_GroundOverlay_native = new WeakMap(), _GroundOverlay_image = new WeakMap();
export class Poi {
    constructor() {
        _Poi_native.set(this, void 0);
    }
    static fromNative(nativePoi) {
        if (nativePoi instanceof com.google.android.gms.maps.model.PointOfInterest) {
            const poi = new Poi();
            __classPrivateFieldSet(poi, _Poi_native, nativePoi, "f");
            return poi;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Poi_native, "f");
    }
    get android() {
        return this.native;
    }
    get coordinate() {
        const coord = this.native.latLng;
        return {
            lat: coord.latitude,
            lng: coord.longitude,
        };
    }
    get name() {
        return this.native.name;
    }
    get placeId() {
        return this.native.placeId;
    }
}
_Poi_native = new WeakMap();
export class TileOverlay {
    constructor() {
        _TileOverlay_native.set(this, void 0);
    }
    static fromNative(nativeOverlay) {
        if (nativeOverlay instanceof com.google.android.gms.maps.model.TileOverlay) {
            const overlay = new TileOverlay();
            __classPrivateFieldSet(overlay, _TileOverlay_native, nativeOverlay, "f");
            return overlay;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _TileOverlay_native, "f");
    }
    get android() {
        return this.native;
    }
    get fadeIn() {
        return this.native.getFadeIn();
    }
    set fadeIn(value) {
        this.native.setFadeIn(value);
    }
    get transparency() {
        return this.native.getTransparency();
    }
    set transparency(value) {
        this.native.setTransparency(value);
    }
    get visible() {
        return this.native.isVisible();
    }
    set visible(value) {
        this.native.setVisible(value);
    }
    get zIndex() {
        return this.native.getZIndex();
    }
    set zIndex(value) {
        this.native.setZIndex(value);
    }
}
_TileOverlay_native = new WeakMap();
export class Tile {
    constructor() {
        _Tile_native.set(this, void 0);
    }
    static get NONE() {
        if (!__classPrivateFieldGet(this, _a, "f", _Tile_NONE)) {
            __classPrivateFieldSet(this, _a, Tile.fromNative(com.google.android.gms.maps.model.TileProvider.NO_TILE), "f", _Tile_NONE);
        }
        return __classPrivateFieldGet(this, _a, "f", _Tile_NONE);
    }
    static fromNative(nativeTile) {
        if (nativeTile instanceof com.google.android.gms.maps.model.Tile) {
            const tileTile = new Tile();
            __classPrivateFieldSet(tileTile, _Tile_native, nativeTile, "f");
            return tileTile;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Tile_native, "f");
    }
    get android() {
        return this.native;
    }
}
_a = Tile, _Tile_native = new WeakMap();
_Tile_NONE = { value: void 0 };
export class TileProvider {
    constructor(callback) {
        _TileProvider_native.set(this, void 0);
        _TileProvider_callback.set(this, void 0);
        if (typeof callback === 'function') {
            __classPrivateFieldSet(this, _TileProvider_callback, callback, "f");
            const ref = new WeakRef(this);
            __classPrivateFieldSet(this, _TileProvider_native, new com.google.android.gms.maps.model.TileProvider({
                getTile(x, y, zoom) {
                    var _b;
                    const owner = ref.get();
                    if (owner) {
                        return ((_b = __classPrivateFieldGet(owner, _TileProvider_callback, "f").call(owner, x, y, zoom)) === null || _b === void 0 ? void 0 : _b.native) || null;
                    }
                    return null;
                },
            }), "f");
        }
    }
    static fromNative(nativeTileProvider) {
        if (nativeTileProvider instanceof com.google.android.gms.maps.model.TileProvider) {
            const tileTileProvider = new TileProvider(null);
            __classPrivateFieldSet(tileTileProvider, _TileProvider_native, nativeTileProvider, "f");
            return tileTileProvider;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _TileProvider_native, "f");
    }
    get android() {
        return this.native;
    }
}
_TileProvider_native = new WeakMap(), _TileProvider_callback = new WeakMap();
export class UrlTileProvider extends TileProvider {
    constructor(callback, size = 256) {
        super(null);
        _UrlTileProvider_native.set(this, void 0);
        _UrlTileProvider_callback.set(this, void 0);
        __classPrivateFieldSet(this, _UrlTileProvider_callback, callback, "f");
        const ref = new WeakRef(this);
        const provider = com.google.android.gms.maps.model.UrlTileProvider.extend({
            getTileUrl(x, y, zoom) {
                const owner = ref.get();
                if (owner) {
                    return new java.net.URL(__classPrivateFieldGet(owner, _UrlTileProvider_callback, "f").call(owner, x, y, zoom) || null);
                }
                return null;
            },
        });
        __classPrivateFieldSet(this, _UrlTileProvider_native, new provider(size, size), "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _UrlTileProvider_native, "f");
    }
}
_UrlTileProvider_native = new WeakMap(), _UrlTileProvider_callback = new WeakMap();
export class Projection {
    constructor() {
        _Projection_native.set(this, void 0);
    }
    static fromNative(nativeProjection) {
        if (nativeProjection instanceof com.google.android.gms.maps.Projection) {
            const projection = new Projection();
            __classPrivateFieldSet(projection, _Projection_native, nativeProjection, "f");
            return projection;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Projection_native, "f");
    }
    get android() {
        return this.native;
    }
    coordinateForPoint(point) {
        const location = this.native.fromScreenLocation(new android.graphics.Point(point.x, point.y));
        return {
            lat: location.latitude,
            lng: location.longitude,
        };
    }
    visibleRegion() {
        return VisibleRegion.fromNative(this.native.getVisibleRegion());
    }
    pointForCoordinate(coordinate) {
        const point = this.native.toScreenLocation(new com.google.android.gms.maps.model.LatLng(coordinate.lat, coordinate.lng));
        return { x: point.x, y: point.y };
    }
}
_Projection_native = new WeakMap();
export class VisibleRegion {
    constructor() {
        _VisibleRegion_native.set(this, void 0);
    }
    static fromNative(nativeVisibleRegion) {
        if (nativeVisibleRegion instanceof com.google.android.gms.maps.model.VisibleRegion) {
            const region = new VisibleRegion();
            __classPrivateFieldSet(region, _VisibleRegion_native, nativeVisibleRegion, "f");
            return region;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _VisibleRegion_native, "f");
    }
    get android() {
        return this.native;
    }
    get farLeft() {
        return {
            lat: this.native.farLeft.latitude,
            lng: this.native.farLeft.longitude,
        };
    }
    get farRight() {
        return {
            lat: this.native.farRight.latitude,
            lng: this.native.farRight.longitude,
        };
    }
    get nearLeft() {
        return {
            lat: this.native.nearLeft.latitude,
            lng: this.native.nearLeft.longitude,
        };
    }
    get nearRight() {
        return {
            lat: this.native.nearRight.latitude,
            lng: this.native.nearRight.longitude,
        };
    }
}
_VisibleRegion_native = new WeakMap();
export class Cap {
    constructor() {
        _Cap_native.set(this, void 0);
    }
    static fromNative(nativeCap) {
        if (nativeCap instanceof com.google.android.gms.maps.model.Cap) {
            const cap = new Cap();
            __classPrivateFieldSet(cap, _Cap_native, nativeCap, "f");
            return cap;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _Cap_native, "f");
    }
    get android() {
        return this.native;
    }
}
_Cap_native = new WeakMap();
export class ButtCap extends Cap {
    constructor() {
        super(...arguments);
        _ButtCap_native.set(this, void 0);
    }
    static fromNative(nativeCap) {
        if (nativeCap instanceof com.google.android.gms.maps.model.ButtCap) {
            const cap = new ButtCap();
            __classPrivateFieldSet(cap, _ButtCap_native, nativeCap, "f");
            return cap;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _ButtCap_native, "f");
    }
    get android() {
        return this.native;
    }
}
_ButtCap_native = new WeakMap();
export class RoundCap extends Cap {
    constructor() {
        super(...arguments);
        _RoundCap_native.set(this, void 0);
    }
    static fromNative(nativeCap) {
        if (nativeCap instanceof com.google.android.gms.maps.model.RoundCap) {
            const cap = new RoundCap();
            __classPrivateFieldSet(cap, _RoundCap_native, nativeCap, "f");
            return cap;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _RoundCap_native, "f");
    }
    get android() {
        return this.native;
    }
}
_RoundCap_native = new WeakMap();
export class SquareCap extends Cap {
    constructor() {
        super(...arguments);
        _SquareCap_native.set(this, void 0);
    }
    static fromNative(nativeCap) {
        if (nativeCap instanceof com.google.android.gms.maps.model.SquareCap) {
            const cap = new SquareCap();
            __classPrivateFieldSet(cap, _SquareCap_native, nativeCap, "f");
            return cap;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _SquareCap_native, "f");
    }
    get android() {
        return this.native;
    }
}
_SquareCap_native = new WeakMap();
export class CustomCap extends Cap {
    constructor(image, width) {
        super();
        _CustomCap_native.set(this, void 0);
        if (typeof width === 'number') {
            __classPrivateFieldSet(this, _CustomCap_native, new com.google.android.gms.maps.model.CustomCap(com.google.android.gms.maps.model.BitmapDescriptorFactory.fromBitmap(image.android), Utils.layout.toDevicePixels(width)), "f");
        }
        else if (image) {
            __classPrivateFieldSet(this, _CustomCap_native, new com.google.android.gms.maps.model.CustomCap(com.google.android.gms.maps.model.BitmapDescriptorFactory.fromBitmap(image.android)), "f");
        }
    }
    static fromNative(nativeCap) {
        if (nativeCap instanceof com.google.android.gms.maps.model.CustomCap) {
            const cap = new CustomCap();
            __classPrivateFieldSet(cap, _CustomCap_native, nativeCap, "f");
            return cap;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _CustomCap_native, "f");
    }
    get android() {
        return this.native;
    }
}
_CustomCap_native = new WeakMap();
export class PatternItem {
    constructor() {
        _PatternItem_native.set(this, void 0);
    }
    static fromNative(nativePattern) {
        if (nativePattern instanceof com.google.android.gms.maps.model.PatternItem) {
            const pattern = new PatternItem();
            __classPrivateFieldSet(pattern, _PatternItem_native, nativePattern, "f");
            return pattern;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _PatternItem_native, "f");
    }
    get android() {
        return this.native;
    }
}
_PatternItem_native = new WeakMap();
export class Dash extends PatternItem {
    constructor(length) {
        super();
        _Dash_native.set(this, void 0);
        __classPrivateFieldSet(this, _Dash_native, new com.google.android.gms.maps.model.Dash(Utils.layout.toDevicePixels(length)), "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _Dash_native, "f");
    }
    get android() {
        return this.native;
    }
}
_Dash_native = new WeakMap();
export class Gap extends PatternItem {
    constructor(length) {
        super();
        _Gap_native.set(this, void 0);
        __classPrivateFieldSet(this, _Gap_native, new com.google.android.gms.maps.model.Gap(Utils.layout.toDevicePixels(length)), "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _Gap_native, "f");
    }
    get android() {
        return this.native;
    }
}
_Gap_native = new WeakMap();
export class Dot extends PatternItem {
    constructor(length) {
        super();
        _Dot_native.set(this, void 0);
        __classPrivateFieldSet(this, _Dot_native, new com.google.android.gms.maps.model.Dot(), "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _Dot_native, "f");
    }
    get android() {
        return this.native;
    }
}
_Dot_native = new WeakMap();
//# sourceMappingURL=index.android.js.map